from math import cos, sin


class PositionType :
    "Enum of positions"""
    N, E, S, O, NE, SE, SO, NO, VOID = range(9)

class Arrow :
    """Arrow class definition defined by :
    _ its abscissa (x, in pixels) 
    _ its ordinate (y, in pixels)
    _ its radius
    
    """

    def __init__(self):
        """Arrow constructor"""
        self.x = 0
        self.y = 0
        self.position = PositionType.VOID
        
    
    def capsule_direction(self, capsule, spaceshift, width, height):
        """Bullet and CowUp collision"""
        #hb_half_length = capsule.hit_box_length / 2. + player.radius
        if capsule.x - width / 2. < self.x < capsule.x + width / 2 and capsule.y - height / 2. > self.y:
            self.position = PositionType.N
            self.x = spaceshift.x
            self.y = spaceshift.y + 150
        if capsule.x - width / 2. > self.x and capsule.y - height / 2. < self.y < capsule.y + height / 2.:
            self.position = PositionType.E
            self.x = spaceshift.x + 150
            self.y = spaceshift.y
        if capsule.x - width / 2. < self.x < capsule.x + width / 2 and capsule.y + height / 2. < self.y:
            self.position = PositionType.S
            self.x = spaceshift.x
            self.y = spaceshift.y - 150
        if capsule.x + width / 2. < self.x and capsule.y - height / 2. < self.y < capsule.y + height / 2.:
            self.position = PositionType.O
            self.x = spaceshift.x - 150
            self.y = spaceshift.y
        
        if capsule.x - width / 2. > self.x and capsule.y - height / 2. > self.y:
            self.position = PositionType.NE
            self.x = spaceshift.x + 150
            self.y = spaceshift.y + 150
        if capsule.x - width / 2. > self.x and capsule.y + height / 2. < self.y:
            self.position = PositionType.SE
            self.x = spaceshift.x + 150
            self.y = spaceshift.y - 150
        if capsule.x + width / 2. < self.x and capsule.y + height / 2. < self.y:
            self.position = PositionType.SO
            self.x = spaceshift.x - 150
            self.y = spaceshift.y - 150
        if capsule.x + width / 2. < self.x and capsule.y - height / 2. > self.y:
            self.position = PositionType.NO
            self.x = spaceshift.x - 150
            self.y = spaceshift.y + 150
        
        if capsule.x - width / 2. < self.x < capsule.x + width / 2 and capsule.y - height / 2. < self.y < capsule.y + height / 2.:
            self.position = PositionType.VOID
            self.x = 0
            self.y = 0
         
         
         
    def update(self, capsule, spaceshift, width, height):
        """Capsule movement"""
        
        self.capsule_direction(capsule, spaceshift, width, height)
